/* gcc -g -Wall -o dumpDeviceAsync dumpDeviceAsync.c */

#include <stdlib.h>
#include <stdio.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <asm/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <linux/hiddev.h>

int main( int argc, char *argv[] ) {
    int i;
    struct hiddev_event packet;
    int fd = -1;

    printf("%s\n", PACKAGE_STRING);
    printf("Send bug reports to %s\n", PACKAGE_BUGREPORT);
  /* requires a file descriptor, so we check we got one, and then open it */

    if (argc < 2)
    {
        fprintf(stderr, "usage: %s hiddevice packet_count - probably /dev/usb/hiddev0\n", argv[0]);
        fprintf(stderr, "\thiddevice : the device to watch - probably /dev/usb/hiddev0\n");
        fprintf(stderr, "\tpacket_count : the number of hid report to read in a row - 6 by default \n");
        exit(1);
    }

    fd = open(argv[1], O_RDONLY | O_NONBLOCK);

    if ((fd = open(argv[1], O_RDONLY)) < 0) {
        fprintf(stderr,"ERROR : Device '%s' could not be open.\n", argv[1]);
        exit(1);
    }
    printf("Device '%s' could be open : ok\n", argv[1]);

    int packet_count = 6 ;
    if (3 == argc)
    {
        packet_count = atoi(argv[2]) ;
    }
    printf("Packets in a row : %i\n", packet_count);
    
    int data_read ;
    unsigned char data ;

	for(;;)
	{
		for(i=0; i<packet_count; i++) {
			data_read = read(fd, &packet, sizeof(packet)) ;
			if (data_read < 0)
			{
				printf("no data\n");
				sleep(50);
				break ;
			}
			printf("%x\t%i\t", packet.hid, packet.value);
		}
		printf("\n");
	}

    close(fd);
	return 0;
}
